config/routes.rb
Rails.application.routes.draw do
  resources :comments
  resources :tasks
  resources :projects
  resources :students
  resources :teachers
  resources :appoitments
  resources :patients
  resources :doctors
  #get 'movies/index'
  resources :movies
  resources :books
  resources :authors
  resources :employees
  root "authors#index"
  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html
end

app/models/appoitment.rb
class Appoitment < ApplicationRecord
  belongs_to :doctor
  belongs_to :patient
end

app/models/author.rb
class Author < ApplicationRecord
	has_many :books
end

app/models/book.rb
class Book < ApplicationRecord
  belongs_to :author
end

app/models/comment.rb
class Comment < ApplicationRecord
  belongs_to :commentable, polymorphic: true
end

app/models/doctor.rb
class Doctor < ApplicationRecord
	has_many :appoitments
	has_many :patients,through: :appoitments
end

app/models/employee.rb
class Employee < ApplicationRecord
end

app/models/movie.rb
class Movie < ApplicationRecord
end

app/models/patient.rb
class Patient < ApplicationRecord
	has_many :appoitments
	has_many :doctors,through: :appoitments
end

app/models/project.rb
class Project < ApplicationRecord
	has_many :comments, as: :commentable
end

app/models/student.rb
class Student < ApplicationRecord
	has_and_belongs_to_many :teachers
end

app/models/task.rb
class Task < ApplicationRecord
	has_many :comments, as: :commentable
end

app/models/teacher.rb
class Teacher < ApplicationRecord
	has_and_belongs_to_many :students
end

app/controllers/tasks_controller.rb
class TasksController < ApplicationController
  before_action :set_task, only: [:show, :edit, :update, :destroy]

  # GET /tasks
  # GET /tasks.json
  def index
    @tasks = Task.all
  end

  # GET /tasks/1
  # GET /tasks/1.json
  def show
  end

  # GET /tasks/new
  def new
    @task = Task.new
  end

  # GET /tasks/1/edit
  def edit
  end

  # POST /tasks
  # POST /tasks.json
  def create
    @task = Task.new(task_params)

    respond_to do |format|
      if @task.save
        format.html { redirect_to @task, notice: 'Task was successfully created.' }
        format.json { render :show, status: :created, location: @task }
      else
        format.html { render :new }
        format.json { render json: @task.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /tasks/1
  # PATCH/PUT /tasks/1.json
  def update
    respond_to do |format|
      if @task.update(task_params)
        format.html { redirect_to @task, notice: 'Task was successfully updated.' }
        format.json { render :show, status: :ok, location: @task }
      else
        format.html { render :edit }
        format.json { render json: @task.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /tasks/1
  # DELETE /tasks/1.json
  def destroy
    @task.destroy
    respond_to do |format|
      format.html { redirect_to tasks_url, notice: 'Task was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_task
      @task = Task.find(params[:id])
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def task_params
      params.require(:task).permit(:title)
    end
end

app/helpers/authors_helper.rb
module AuthorsHelper
end

app/helpers/books_helper.rb
module BooksHelper
end

app/helpers/comments_helper.rb
module CommentsHelper
end

app/helpers/doctors_helper.rb
module DoctorsHelper
end

app/helpers/movies_helper.rb
module MoviesHelper
end

app/helpers/patients_helper.rb
module PatientsHelper
end

app/helpers/projects_helper.rb
module ProjectsHelper
end

app/helpers/students_helper.rb
module StudentsHelper
end

app/helpers/tasks_helper.rb
module TasksHelper
end

app/helpers/teachers_helper.rb
module TeachersHelper
end

app/views/tasks/_form.html.erb
<%= form_with(model: task, local: true) do |form| %>
  <% if task.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(task.errors.count, "error") %> prohibited this task from being saved:</h2>

      <ul>
      <% task.errors.full_messages.each do |message| %>
        <li><%= message %></li>
      <% end %>
      </ul>
    </div>
  <% end %>

  <div class="field">
    <%= form.label :title %>
    <%= form.text_field :title, id: :task_title %>
  </div>

  <div class="actions">
    <%= form.submit %>
  </div>
<% end %>

app/views/tasks/edit.html.erb
<h1>Editing Task</h1>

<%= render 'form', task: @task %>

<%= link_to 'Show', @task %> |
<%= link_to 'Back', tasks_path %>

app/views/tasks/index.html.erb
<p id="notice"><%= notice %></p>

<h1>Tasks</h1>

<table>
  <thead>
    <tr>
      <th>Title</th>
      <th colspan="3"></th>
    </tr>
  </thead>

  <tbody>
    <% @tasks.each do |task| %>
      <tr>
        <td><%= task.title %></td>
        <td><%= link_to 'Show', task %></td>
        <td><%= link_to 'Edit', edit_task_path(task) %></td>
        <td><%= link_to 'Destroy', task, method: :delete, data: { confirm: 'Are you sure?' } %></td>
      </tr>
    <% end %>
  </tbody>
</table>

<br>

<%= link_to 'New Task', new_task_path %>

app/views/tasks/new.html.erb
<h1>New Task</h1>

<%= render 'form', task: @task %>

<%= link_to 'Back', tasks_path %>

app/views/tasks/show.html.erb
<p id="notice"><%= notice %></p>

<p>
  <strong>Title:</strong>
  <%= @task.title %>
</p>

<%= link_to 'Edit', edit_task_path(@task) %> |
<%= link_to 'Back', tasks_path %>